<template>
  <div>
    <slot name="modals-slot"></slot>

    <div class="row mb-2">
      <div class="col-md-4">
        <h3 class="text-primary">{{tableName}}</h3>
      </div>
      <div class="col-md-8">
        <div class="row justify-content-end">
          <div class="col-6 col-md-2" v-show="isFiltered">
            <button class="btn btn-danger capsule btn-block" @click="filterReset">
              Clear
              <i class="fas fa-times"></i>
            </button>
          </div>

          <slot name="header-slot"></slot>
          <filter-bar></filter-bar>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12 table-responsive">
        <div v-show="loading">
          <vue-content-loading :width="300" :height="100">
            <rect x="0" y="10" rx="4" ry="4" width="60" height="10"/>
            <rect x="70" y="10" rx="4" ry="4" width="60" height="10"/>
            <rect x="0" y="23" rx="2" ry="2" width="300" height="10"/>
            <rect x="0" y="35" rx="2" ry="2" width="300" height="10"/>
            <rect x="0" y="47" rx="2" ry="2" width="300" height="10"/>
            <rect x="0" y="59" rx="2" ry="2" width="300" height="10"/>
            <rect x="0" y="71" rx="2" ry="2" width="300" height="10"/>
          </vue-content-loading>
        </div>
        <div v-show="!loading">
          <vuetable
            ref="vuetable"
            pagination-path
            @vuetable:pagination-data="onPaginationData"
            :api-url="apiUrl"
            :css="css.table"
            :per-page="perPage"
            @vuetable:loading="onLoading"
            @vuetable:loaded="onLoaded"
            :fields="fields"
            :http-options="httpOptions"
            :appendParams="moreParams"
          >
            <div slot="sequence-slot" slot-scope="props">{{ props.rowIndex + 1}}</div>
            <div slot="actions-slot" slot-scope="props">
              <slot name="actions-slot" :rowData="props.rowData" :rowIndex="props.rowIndex"></slot>
            </div>
            <div slot="column1-slot" slot-scope="props">
              <slot name="column1-slot" :rowData="props.rowData" :rowIndex="props.rowIndex"></slot>
            </div>
            <div slot="column2-slot" slot-scope="props">
              <slot name="column2-slot" :rowData="props.rowData" :rowIndex="props.rowIndex"></slot>
            </div>
            <div slot="column3-slot" slot-scope="props">
              <slot name="column3-slot" :rowData="props.rowData" :rowIndex="props.rowIndex"></slot>
            </div>
          </vuetable>
          <!-- pagination -->
          <vuetable-pagination-info ref="paginationInfo" class="float-left"></vuetable-pagination-info>
          <vuetable-pagination
            @vuetable-pagination:change-page="onChangePage"
            ref="pagination"
            :css="css.pagination"
          ></vuetable-pagination>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {
  Vuetable,
  VuetablePagination,
  VuetablePaginationInfo
} from "vuetable-2";
import FilterBar from "./FilterBar";
import TableStyle from "./TableStyle";
import EventBus from "@/EventBus.js";
import VueContentLoading from "vue-content-loading";

export default {
  name: "my-vuetable",
  components: {
    Vuetable,
    VuetablePagination,
    VuetablePaginationInfo,
    FilterBar,
    VueContentLoading
  },
  props: {
    apiUrl: {
      type: String,
      required: true
    },
    perPage: {
      required: true
    },
    fields: {
      type: Array,
      required: true
    },
    tableName: {
      type: String,
      required: true
    },
    sortOrder: {
      type: Array,
      default() {
        return [];
      }
    },
    appendParams: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  mounted() {
    EventBus.$on("tableFilterSet", value => {
      this.filterSet(value);
    });
    EventBus.$on("tableFilterReset", value => {
      this.filterReset(value);
    });
    EventBus.$on("refreshTable", value => {
      this.refreshTable();
    });
  },
  data() {
    return {
      httpOptions: this.$store.getters["general/httpOptions"],
      css: TableStyle,
      moreParams: {},
      loading: false,
      isFiltered: false
    };
  },
  methods: {
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData);
      this.$refs.paginationInfo.setPaginationData(paginationData);
    },
    onChangePage(page) {
      this.$refs.vuetable.changePage(page);
    },
    onLoading() {
      this.loading = true;
    },
    onLoaded() {
      this.loading = false;
    },
    filterSet(filterData) {
      this.isFiltered = true;
      this.moreParams = { ...filterData };
      this.$nextTick(() => this.$refs.vuetable.refresh());
    },
    filterReset() {
      this.isFiltered = false;
      this.moreParams = {};
      this.$nextTick(() => this.$refs.vuetable.refresh());
    },
    refreshTable() {
      this.$nextTick(() => this.$refs.vuetable.refresh());
    }
  }
};
</script>
